@import url('https://fonts.googleapis.com/css2?family=Fira+Code:wght@300..700&display=swap');
@import url('https://fonts.googleapis.com/css2?family=Pixelify+Sans:wght@400..700&display=swap');

:root {
    --mt-grey-100: #a3aec9;
    --mt-grey-200: #828394;
    --mt-blue-100: #20a7f2;
    --mt-blue-200: #314dee;
    --mt-blue-300: #121b63;
    --mt-blue-400: #000212;
    --mt-blue-hover: rgba(2, 165, 225, .83);
    --mt-blue-border: #0a1730;
    --mt-red-100: #f84f54;
    --mt-red-200: #e10202;
    --mt-red-300: #e10202c4;
    --mt-green-100: #3dbe58;
    --mt-green-200: #309746;
    --mt-yellow-100: #ffff00;
    --mt-yellow-200: #f3c137;
    --mt-pink-100: #e1d0fe;
    --mt-pink-200: #ff43ef;
    --font-main: 'Fira Code', monospace;
    --font-pixel: 'Pixelify Sans', sans-serif;
}

::selection {
    color: var(--mt-blue-100);
    background-color: #fff;
}

::-moz-selection,
::-webkit-selection {
    color: var(--mt-blue-100);
    background-color: #fff;
}

* {
    box-sizing: border-box;
    margin: 0;
    padding: 0;
}

body {
    min-height: 100vh;
    background: linear-gradient(to top right, var(--mt-blue-400) 50%, var(--mt-blue-300));
    font-family: var(--font-main);
    overflow: hidden;
}

main {
    display: flex;
    height: 100vh;
}

aside {
    max-width: 25em;
    height: 100vh;
    padding: 20px 30px;
    background-color: rgba(0, 0, 0, 0.4);
    border-right: 1px solid var(--mt-blue-border);
    display: flex;
    flex-direction: column;
    gap: 50px;
}

aside #mtLogo {
    width: fit-content;
    display: flex;
    gap: 10px;
    align-items: center;
    text-decoration: none;
    font-family: var(--font-pixel);
    font-size: 1rem;
    color: #fff;
}

aside #mtLogo img {
    width: 30px;
    height: auto;
    transition: transform 0.3s ease-in-out;
}

aside #mtLogo:hover img {
    transform: scale(1.10) rotate(3deg);
}

aside header {
    display: flex;
    flex-direction: column;
    gap: 50px;
    flex: 1
}

header .settings {
    display: flex;
    flex-direction: column;
    gap: 10px;
}

header label {
    color: var(--mt-grey-200);
    margin-bottom: 5px;
}

header select,
header button {
    width: 280px;
    height: 40px;
    padding: .375rem .75rem;
    font-size: 1rem;
    font-weight: 400;
    line-height: 1.5;
    cursor: pointer;
    color: #212529;
    background-color: #fff;
    background-clip: padding-box;
    border: 1px solid #ced4da;
    border-radius: .25rem;
    transition: .15s ease-in-out;
}

header button:disabled,
header select:disabled {
    cursor: not-allowed;
    opacity: 0.5;
}

header select:focus {
    outline: none;
    box-shadow: none;
}

header button {
    color: #fff;
    border: none;
    background-color: var(--mt-blue-100);
}

header button:hover {
    background-color: var(--mt-blue-hover);
}

header .moreButtons {
    display: flex;
    flex-direction: column;
    gap: 15px;
}

header #clearButton {
    background-color: var(--mt-green-100);
}

header #clearButton:hover {
    background-color: var(--mt-green-200);
}

header #stopButton {
    background-color: var(--mt-red-200);
}

header #stopButton:hover {
    background-color: var(--mt-red-300);
}

footer {
    font-size: 1rem;
    color: var(--mt-grey-200);
    text-align: center;
}

footer a {
    color: var(--mt-blue-100);
    text-decoration: none;
    transition: .15s ease-in-out;
}

footer a:hover {
    text-decoration: underline;
    color: #fff;
}

section {
    display: flex;
    width: 100%;
    padding: 20px;
}

#maze {
    display: grid;
    justify-content: center;
    width: 100%;
    height: 100%;
}

#maze .cell {
    background-color: var(--mt-blue-400);
    border: 1px solid var(--mt-blue-border);
}

#maze button {
    cursor: pointer;
}

#maze div {
    user-select: none;
    pointer-events: none;
}

#maze button:focus {
    outline: none;
    box-shadow: none;
}

#maze .wall {
    background: var(--mt-blue-100);
    border: none;
}

#maze .path {
    background-color: var(--mt-pink-100);
    border: none;
}

#maze .entry {
    background-color: var(--mt-yellow-100);
    border: 1px solid #fff;
    cursor: grab;
}

#maze .exit {
    background-color: var(--mt-pink-200);
    border: 1px solid #fff;
    cursor: grab;
}

#maze .wallAnimation {
    animation: scaleBounce .5s;
}

#maze .dragging {
    animation: blink .8s infinite;
}

@keyframes scaleBounce {
    0% {
        transform: scale(.3);
        opacity: .75;
    }

    50% {
        transform: scale(1.2);
        opacity: .9;
    }

    100% {
        transform: scale(1);
        opacity: 1;
    }
}

@keyframes blink {
    0% {
        opacity: 1;
    }

    50% {
        opacity: 0.5;
    }

    100% {
        opacity: 1;
    }
}

#toast {
    position: fixed;
    top: 10px;
    left: 60%;
    transform: translateX(-50%);
    display: flex;
    align-items: center;
    padding: 12px 20px;
    border-radius: 8px;
    box-shadow: 0 4px 5px rgba(0, 0, 0, 0.4);
    background-color: #15182b;
    opacity: 0;
    visibility: hidden;
    transition: opacity 0.5s ease, visibility 0.5s ease;
    z-index: 1000;
    font-size: 13px;
}

#toast.show {
    opacity: 1;
    visibility: visible;
}

#toast .toastContent {
    display: flex;
    gap: 15px;
    align-items: center;
}

#toast .toastIcon {
    width: 24px;
    height: 24px;
}

#toast .toastTitle {
    font-weight: bold;
    margin-bottom: 2px;
}

#toast .toastMessage {
    color: var(--mt-grey-100);
}

#toast.toastSuccess .toastTitle,
#toast.toastSuccess .toastIcon {
    color: var(--mt-green-100);
}

#toast.toastInfo .toastTitle {
    color: var(--mt-blue-100);
}

#toast.toastWarning .toastTitle,
#toast.toastWarning .toastIcon {
    color: var(--mt-yellow-200);
}

#toast.toastError .toastTitle,
#toast.toastError .toastIcon {
    color: var(--mt-red-100);
}

.particle {
    position: absolute;
    border-radius: 50%;
    background: var(--mt-blue-200);
    opacity: 0.8;
    pointer-events: none;
    width: 5px;
    height: 5px;
    z-index: -50;
}

#openHambMenu,
#closeHambMenu {
    display: none;
    flex-direction: column;
    justify-content: space-around;
    width: 30px;
    height: 30px;
    cursor: pointer;
}

#openHambMenu {
    position: absolute;
    top: 20px;
    left: 20px;
}

#closeHambMenu {
    position: relative;
}

#openHambMenu span,
#closeHambMenu span {
    width: 100%;
    height: 3px;
    background-color: white;
}

#closeHambMenu span {
    position: absolute;
    display: block;
    transform-origin: center center;
}

#closeHambMenu span:nth-child(1) {
    transform: rotate(45deg);
}

#closeHambMenu span:nth-child(2) {
    transform: rotate(-45deg);
}

.logoMenu {
    display: flex;
    justify-content: space-between;
    align-items: center;
}

@media (max-width: 650px) {
    aside {
        position: absolute;
        left: -100%;
        background-color: rgba(0, 0, 0, 0.8);
        backdrop-filter: blur(20px);
        -webkit-backdrop-filter: blur(20px);
        border: none;
        transition: left 0.3s;
    }

    aside.open {
        left: 0;
    }

    #openHambMenu,
    #closeHambMenu {
        display: flex;
    }

    #closeHambMenu {
        justify-content: center;
    }

    section {
        margin-left: 40px;
    }
}